REM ********************************************************************************
REM Programme de recherche de fichiers multicriteres TM 2003-2007
REM toute suggestion bienvenue thierry.mahieux@free.fr 
REM http://thierry.mahieux.free.fr
REM ********************************************************************************

:INITVAR   *********************** Initialisation variables ************************

REM nettoyage fichiers residuels des eventuelles precedentes utilisations

  ECHO off
  SET  outfile=%temp%\rech_output.txt
  IF EXIST %outfile% ERASE %outfile%

REM On considerera tous les fichiers plus bas dans tous les sous repertoires SANS 
REM les sous repertoires

  SET  basecmd=DIR /A-D/B/S

  REM recherche de 10 chaines maximum
  SET max=10

REM definition de quelques constantes (chaines d'affichage)

  SET  basedir= %CD%\...
  SET  goodbye=__________________________ Au Revoir et.... Merci!!! __________________________
  SET  titre=   Programme de Recherche multicriteres de fichiers  %date%  TM 2003-2006
  REM SET ligne=*******************************************************************************
  SET    ligne=_______________________________________________________________________________
  SET q0=(Optionnel) Fichier(s) commencant par: 
  SET qe=(Optionnel) Fichier(s) finissant par: 
  SET q1a=Chaine
  SET q1b=a rechercher : 
  SET qnb=Nombre de chaines a rechercher [0-%max%](0 pour sortir)(1): 
  SET ite=Appuyer sur une touche pour quitter le programme
  SET aideentree=Entrez un nombre entre 0 et %max%!!! 
  SET preciser=Votre recherche est trop generale et donnerait lieu a beaucoup trop de fichiers correspondants, veuillez preciser 
  SET specifique=    Soyez plus specifique, choisissez parmi les fichiers suivants: 
  SET mode=cmdline
  SET bv=
  REM SET ouv=**************************** Ouverture du fichier *****************************
  SET     ouv=____________________________ Ouverture du fichier _____________________________


  CLS & COLOR 1F &TITLE %titre% & ECHO %ligne%& ECHO *%titre%*& ECHO %ligne%
 
:analyseinputs

  

  SET chaine=%1*%2*%3*%4*%5*%6*%7*%8*%9
  IF %errorlevel%==0 (IF NOT %chaine%==******** ( GOTO continuer))
  
:debut *****************************************************************************
  SET mode=interactif
  CLS & COLOR 1F &TITLE %titre% & ECHO %ligne%& ECHO %bv%%titre%%BV%& ECHO %ligne%
  

REM ***************** Elaboration de la chaine a rechercher ************************

 
  SET chaine=0 
  FOR /L %%i IN (1,1,%max%) DO SET  chaine%%i=0

REM ***************************** fichier commencant par ***************************

  SET add=0 & SET /P add="%q0%"
  IF %add% EQU 0 (SET commence=*) ELSE (SET commence=%add%*)
  SET concat=%commence%

REM ***************************** fichier contenant ********************************

:nb
  SET nbcrit=1 & SET /P nbcrit="%qnb%" 
  IF %nbcrit% GTR %max% (echo %aideentree%& GOTO nb)
  IF %nbcrit% EQU 0 GOTO sortie
 
  FOR /L %%i IN (1,1,%nbcrit%) DO SET  /P chaine%%i="%q1a% %%i %q1b%" 

  SET /A I=1 & SET /A fin=%nbcrit%+1

:boucle 
 
 	IF %I% EQU 1   SET add=%chaine1%
	IF %I% EQU 2   SET add=%chaine2%
	IF %I% EQU 3   SET add=%chaine3%
	IF %I% EQU 4   SET add=%chaine4%
	IF %I% EQU 5   SET add=%chaine5%
	IF %I% EQU 6   SET add=%chaine6%
	IF %I% EQU 7   SET add=%chaine7%
	IF %I% EQU 8   SET add=%chaine8%
	IF %I% EQU 9   SET add=%chaine9%
	IF %I% EQU 10  SET add=%chaine10%

  IF %add% NEQ 0 SET concat=%concat%%add%*

  SET /A I=I+1

  IF %I% EQU %fin% GOTO suite

GOTO boucle
  
:suite  ***************************** fichier finissant par ************************
  SET add=0
  SET /P add="%qe%"

  IF %add% NEQ 0 SET concat=%concat%%add%

  SET chaine=%concat%
  IF %chaine%==* (echo. &Echo %preciser%&echo.& pause & GOTO debut)


REM ************************************ Debut de Recherche ************************
:continuer

  IF %chaine%==?******** GOTO help
  SET /A mem="rien" & SET match=0

REM ****************************** Constitution d'un fichier de references *********
 
 
  %basecmd% %chaine% > %outfile%


REM ************************************Affichage Resultats*************************

  CLS & ECHO %ligne%& ECHO %bv%%titre%%bv%& ECHO %ligne% 
  FOR /F "eol=" %%i IN (%outfile%) DO SET/A match=match+1
 
  ECHO     dans %basedir%, & ECHO     en mode %mode%, en excluant les classeurs, 
  IF %match% GTR 1 (
     ECHO     %match% Fichiers %chaine% correspondent  
     ) ELSE (
     ECHO     %match% Fichier %chaine% correspond
     )
  IF %match% NEQ 1 GOTO erreurs

REM cette ligne depend du nombre d'espaces dans un nom de fichier complet
  FOR /F  "eol=; tokens=1-6" %%i IN (%outfile%) DO SET mem="%%i %%j %%k %%l %%m %%n"

  ECHO     %mem% &  COLOR 2F & GOTO  executer


:Erreurs ***************************** pas trouv **********************************
  ECHO. &  IF %match% EQU 0 (COLOR CF & GOTO Finerreur)

:ERRplus ***************************** pas assez precis ****************************
  COLOR 5F & ECHO %specifique%&  ECHO.     
  IF %match% LEQ 10 (type %outfile% ) ELSE (TYPE %outfile%  |more)

:Finerreur
  ECHO. & PAUSE & GOTO debut

:Executer **************************************************************************
  ECHO. &  ECHO %ouv%
  %mem% 

 IF %mode%==interactif (GOTO debut) ELSE (GOTO sortie)


:help

CLS
ECHO %LIGNE%&TITLE  AIDE :%titre% 
ECHO AIDE SUR LE PROGRAMME RECH
ECHO.
ECHO Usage : RECH P1 P2 P3 P4 P5 P6 P7 P8 P9    (mode cmdline) 
ECHO    ou : RECH                               (mode interactif)
ECHO    ou : RECH ?                             (cette aide en ligne)
ECHO.
ECHO      1/ si les parametres de 1 a 9 sont fournis: 
ECHO         P1 sera le debut de la chaine a rechercher
ECHO         P9 sera la fin de la chaine a rechercher
ECHO         Les parametres de 2 a 8 seront des chaines contenues dans la chaine 
ECHO         a rechercher. 
ECHO         Les parametres inutilises peuvent etre REMplaces par des *.          
ECHO.
ECHO      2/ si les parametres ne sont pas fournis:
ECHO         le mode interactif demandera en clair les informations ad-hoc a 
ECHO         l'utilisateur pour identIFier le fichier a rechercher
ECHO.
ECHO      Exemples:
ECHO.
ECHO      RECH fiches * paie * septembre * * * 2006
ECHO  ou  RECH
ECHO.
ECHO %LIGNE%
pause
cls
title %titre%

:sortie  ***************************************************************************

  IF EXIST %outfile% ERASE %outfile% 
  ECHO. &  COLOR & ECHO %goodbye% & ECHO.
  SET chaine=0 & Title CMD
  IF %mode%==interactif SET /P aurevoir="%ite%"  


